"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FronteggIdleSessionHelper = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var attributes = {
  APP_URL: 'app-url',
  MESSAGE_ID: 'message-id'
};
var defaultPostMessageId = 'FE_CLEAR_IDLE_TIMEOUT';
var FronteggIdleSessionHelper = /*#__PURE__*/function (_HTMLElement) {
  (0, _inherits2["default"])(FronteggIdleSessionHelper, _HTMLElement);
  var _super = _createSuper(FronteggIdleSessionHelper);
  function FronteggIdleSessionHelper() {
    var _this;
    (0, _classCallCheck2["default"])(this, FronteggIdleSessionHelper);
    _this = _super.call(this);
    _this.appUrl = null;
    _this.events = ['mousemove', 'scroll', 'keydown'];
    _this.postMessageId = defaultPostMessageId;
    _this.sendPostMessage = _this.sendPostMessage.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }
  (0, _createClass2["default"])(FronteggIdleSessionHelper, [{
    key: "sendPostMessage",
    value: function sendPostMessage() {
      var _window;
      if (this.appUrl && (_window = window) != null && _window.parent) {
        window.parent.postMessage(this.postMessageId, this.appUrl);
      }
    }
  }, {
    key: "addEventListeners",
    value: function addEventListeners() {
      var _this2 = this;
      this.events.forEach(function (event) {
        window.addEventListener(event, _this2.sendPostMessage);
      });
    }
  }, {
    key: "removeEventListeners",
    value: function removeEventListeners() {
      var _this3 = this;
      this.events.forEach(function (event) {
        window.removeEventListener(event, _this3.sendPostMessage);
      });
    }
  }, {
    key: "connectedCallback",
    value: function connectedCallback() {
      var _this$getAttribute;
      this.appUrl = this.getAttribute(attributes.APP_URL);
      this.postMessageId = (_this$getAttribute = this.getAttribute(attributes.MESSAGE_ID)) != null ? _this$getAttribute : this.postMessageId;
      this.addEventListeners();
    }
  }, {
    key: "disconnectedCallback",
    value: function disconnectedCallback() {
      this.removeEventListeners();
    }
  }, {
    key: "attributeChangedCallback",
    value: function attributeChangedCallback(name, oldValue, newValue) {
      if (name === attributes.APP_URL && oldValue !== newValue) {
        this.appUrl = newValue;
        this.removeEventListeners();
        this.addEventListeners();
      }
    }
  }]);
  return FronteggIdleSessionHelper;
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(HTMLElement));
exports.FronteggIdleSessionHelper = FronteggIdleSessionHelper;