"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _FrontegggIdleSession = require("./FrontegggIdleSession");
var feIdleSessionTimeoutCustomElementName = 'fe-idle-session-plugin';
var fronteggAppUrlAttributeName = 'app-url';
var fronteggHelperIdAttributeName = 'helper-id';
var fronteggIdleSessionTimeoutHelperId = 'idleSessionClearTimeout';
var fronteggHelpersSrcPrefix = 'https://cdn.jsdelivr.net/npm/@frontegg/js';
var mapHelperIdToCustomElementName = (0, _defineProperty2["default"])({}, fronteggIdleSessionTimeoutHelperId, feIdleSessionTimeoutCustomElementName);
function definedFronteggHelpersCustomElements() {
  if (typeof window !== 'undefined' && window.customElements) {
    customElements.define(feIdleSessionTimeoutCustomElementName, _FrontegggIdleSession.FronteggIdleSessionHelper);
  }
}
function executeFronteggHelpers() {
  if (typeof window !== 'undefined' && typeof document !== 'undefined') {
    var scripts = Array.from(document.querySelectorAll('script'));
    var fronteggHelperScript = scripts == null ? void 0 : scripts.find(function (script) {
      var _script$getAttribute;
      return (_script$getAttribute = script.getAttribute('src')) == null ? void 0 : _script$getAttribute.startsWith(fronteggHelpersSrcPrefix);
    });
    if (fronteggHelperScript) {
      var _fronteggHelperScript;
      var _extractAttributesFro = extractAttributesFromScriptSrc((_fronteggHelperScript = fronteggHelperScript.getAttribute('src')) != null ? _fronteggHelperScript : ''),
        appUrl = _extractAttributesFro.appUrl,
        helperId = _extractAttributesFro.helperId;
      switch (helperId) {
        case fronteggIdleSessionTimeoutHelperId:
          if (appUrl) {
            appendCustomElementToDocument(helperId, [{
              key: fronteggAppUrlAttributeName,
              value: appUrl
            }]);
          }
          break;
        default:
          return;
      }
    }
  }
}
function extractAttributesFromScriptSrc(src) {
  try {
    var url = new URL(src);
    var scriptParams = Object.fromEntries(url.searchParams);
    var appUrl = scriptParams[fronteggAppUrlAttributeName];
    var helperId = scriptParams[fronteggHelperIdAttributeName];
    return {
      appUrl: appUrl,
      helperId: helperId
    };
  } catch (e) {
    return {};
  }
}
function appendCustomElementToDocument(helperId, attributes) {
  var elementName = mapHelperIdToCustomElementName[helperId];
  var customFronteggHelper = document.createElement(elementName);
  attributes.forEach(function (_ref) {
    var key = _ref.key,
      value = _ref.value;
    return customFronteggHelper.setAttribute(key, value);
  });
  document.body.appendChild(customFronteggHelper);
}
definedFronteggHelpersCustomElements();
executeFronteggHelpers();