"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getThemeByName = exports.defaultTheme = exports["default"] = exports.LoginBoxRenderer = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _reduxStore = require("@frontegg/redux-store");
var _types = require("@frontegg/types");
var _FronteggApp = require("../FronteggApp");
var _utils = require("../utils");
var defaultTheme = 'modern';
exports.defaultTheme = defaultTheme;
var getThemeByName = function getThemeByName(name) {
  var _name;
  // Load themes from window chunk to support cdn getThemeByName
  var themes = window['FronteggAdminPortal'].themes;
  return (_name = themes[name]) != null ? _name : themes[defaultTheme];
};
exports.getThemeByName = getThemeByName;
var LoginBoxRenderer = /*#__PURE__*/function () {
  function LoginBoxRenderer(name, themeOptions, store, appOptions) {
    var allowMultipleRenderers = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : true;
    (0, _classCallCheck2["default"])(this, LoginBoxRenderer);
    this.app = void 0;
    this.options = void 0;
    this.store = void 0;
    this.themeSetter = void 0;
    this.setRoute = function () {};
    this.themeOptions = {};
    var contextOptions = {
      baseUrl: 'preview'
    };
    if (store) {
      this.store = store;
      if (!allowMultipleRenderers && store.getState().root.appName !== name) {
        throw Error('Mismatch in store names');
      }
    } else {
      this.store = (0, _reduxStore.createFronteggStore)({
        context: contextOptions,
        appName: name
      }, this, true, undefined, undefined, true);
    }
    this.options = Object.assign({
      themeOptions: themeOptions,
      iframeRendering: true,
      metadata: {},
      previewMode: true,
      builderMode: true,
      store: this.store,
      contextOptions: contextOptions,
      onRedirectTo: function onRedirectTo() {
        // eslint-disable-next-line no-console
        console.debug('path');
      }
    }, appOptions);
    this.app = new _FronteggApp.FronteggApp(this.options, name, true, allowMultipleRenderers);
    _types.Metadata.set({}, name);
  }
  (0, _createClass2["default"])(LoginBoxRenderer, [{
    key: "render",
    value: function () {
      var _render = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(loginBoxContainer) {
        var _this = this;
        var loginBoxEl, setThemeSetter, setStaticRouteSetter, FronteggLoginBox;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              loginBoxEl = loginBoxContainer.querySelector('#root');
              if (!loginBoxEl) {
                loginBoxEl = loginBoxContainer.ownerDocument.createElement('div');
                loginBoxEl.setAttribute('id', 'root');
                loginBoxContainer.appendChild(loginBoxEl);
              }
              this.app.loginBoxContainer = loginBoxContainer;
              this.app.loginBoxEl = loginBoxEl;
              setThemeSetter = function setThemeSetter(themeSetter) {
                _this.themeSetter = themeSetter;
              };
              setStaticRouteSetter = function setStaticRouteSetter(setStaticRoute) {
                _this.setRoute = setStaticRoute;
              };
              _context.next = 8;
              return this.app.loadScript('FronteggLoginBox');
            case 8:
              FronteggLoginBox = _context.sent;
              this.app.loginBoxRenderer = FronteggLoginBox.renderPage(loginBoxEl, {
                options: this.options,
                injector: this.app,
                setThemeSetter: setThemeSetter,
                setStaticRouteSetter: setStaticRouteSetter,
                staticRoute: '/account/login'
              });
              _context.next = 12;
              return (0, _utils.waitThemeSetter)(this);
            case 12:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function render(_x) {
        return _render.apply(this, arguments);
      }
      return render;
    }()
  }, {
    key: "unmount",
    value: function unmount() {
      try {
        var _this$app$loginBoxRen;
        (_this$app$loginBoxRen = this.app.loginBoxRenderer) == null ? void 0 : _this$app$loginBoxRen.unmount();
      } catch (e) {
        console.error('Failed to unmount login box renderer', e);
      }
    }
  }, {
    key: "setTheme",
    value: function setTheme(themeOptions) {
      var _this$themeSetter;
      this.themeOptions = themeOptions;
      if (!this.themeSetter) {
        console.warn('this.themeSetter is not defined yet');
      }
      (_this$themeSetter = this.themeSetter) == null ? void 0 : _this$themeSetter.call(this, this.themeOptions);
    }
  }, {
    key: "setStaticRoute",
    value: function setStaticRoute(staticRoute) {
      var _this$setRoute;
      if (!this.setRoute) {
        console.warn('this.setRoute is not defined yet');
      }
      (_this$setRoute = this.setRoute) == null ? void 0 : _this$setRoute.call(this, staticRoute);
    }
  }, {
    key: "setStore",
    value: function setStore(state) {
      this.store.dispatch({
        type: 'auth/setState',
        payload: state
      });
    }
  }]);
  return LoginBoxRenderer;
}();
exports.LoginBoxRenderer = LoginBoxRenderer;
var _default = LoginBoxRenderer;
exports["default"] = _default;